=== debian/changelog ===
cp2k (5.1-3) unstable; urgency=medium

  * debian/patches/makeflags.patch: Add _LIBINT_MAX_AM and __LIBDERIV_MAX_AM1
    defines.

 -- Michael Banck <mbanck@debian.org>  Mon, 15 Jan 2018 12:02:20 +0100

cp2k (5.1-2) unstable; urgency=medium

  * debian/patches/fix_32bit_build_failure.patch: New patch, fixes an integer
    overflow on 32bit architectures, taken from upstream revision 18196.

 -- Michael Banck <mbanck@debian.org>  Mon, 08 Jan 2018 14:50:15 +0100

cp2k (5.1-1) unstable; urgency=medium

  * New upstream release, new features include:
    + Constraint DFT
    + Cubic scaling GW
    + Constraint cell optimization
  * debian/control (Build-Depends): Added libblacs-mpi-dev. 

 -- Michael Banck <mbanck@debian.org>  Sun, 07 Jan 2018 14:36:39 +0100
