=== debian/changelog ===
cp2k (6.1-3ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:36:49 +0100

cp2k (6.1-3ubuntu1) focal; urgency=medium

  * Build-Depend on python2 instead of python
  * Replace python shebangs with python2
  * Revert to building with libint (as in 6.1-2), see #948909

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 15 Jan 2020 05:54:02 +0000

cp2k (6.1-3build1) focal; urgency=medium

  * No-change rebuild against libscalapack-openmpi2.1

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 04 Jan 2020 20:11:17 +0000

cp2k (6.1-3) unstable; urgency=medium

  * debian/control (Builds-Depends): Added libsymspg-dev.
  * debian/patches/makeflags.patch: Added -D__SPGLIB to DFLAGS.
  * debian/control (Build-Depends): Switch from libint-dev to libint2-dev.
  * debian/patches/makeflags.patch: Update for libint -> libint2 switch.
  * debian/patches/libint2_support.patch: New patch, adds support for libint2,
    taken from upstream commit 20ad1a1b.
  * debian/salsa-ci.yml: New file.

 -- Michael Banck <mbanck@debian.org>  Wed, 28 Aug 2019 14:06:03 +0200

cp2k (6.1-2) unstable; urgency=medium

  * debian/tests: Added autopkgtests based on upstream's regtesting framework.
  * debian/patches/makeflags.patch: Link libint and libderiv statically for
    now.
  * debian/rules (override_dh_auto_test): Update test directories.
  * debian/rules: Do not fail if mpi-default-dev/debian_defaults is missing.

 -- Michael Banck <mbanck@debian.org>  Sun, 06 Jan 2019 18:20:04 +0100

cp2k (6.1-1) unstable; urgency=medium

  * New upstream release, new features include:
    + Projection-operator diabatization (POD) method

  [ Michael Banck ]
  * debian/watch: Updated for GitHub.
  * debian/patches/fix_32bit_build_failure.patch: Removed, no longer needed.
  * debian/patches/makeflags.patch: Update LibXC and ELPA definitions.
  * debian/patches/makeflags.patch: Add /usr/include/elpa/elpa to include
    directories.
  * debian/patches/makeflags.patch: Link against libxcf03 instead of libxcf90.
  * debian/patches/testsuite_output.patch: Refreshed.
  * debian/patches/libxc3_support.patch: Removed, no longer needed.

 -- Michael Banck <mbanck@debian.org>  Thu, 20 Dec 2018 16:48:02 +0100

cp2k (5.1-4) unstable; urgency=medium

  * Acknowledge 4.1-1.1 NMU.
  * debian/control (Build-Depends): Removed libblacs-mpi-dev (Closes: #886710).

 -- Michael Banck <mbanck@debian.org>  Tue, 01 May 2018 15:21:01 +0200

cp2k (4.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Standards-Version: 4.1.0
  * debhelper compatibility level 10
  * Build-Depends: libscalapack-mpi-dev (>= 2)
    - use LIB_BLACS=$(LIB_SCALAPACK)
      (BLACS is now included in scalapack2)

 -- Drew Parsons <dparsons@debian.org>  Mon, 11 Sep 2017 00:47:53 +0800
