=== debian/control ===
--- 
+++ 
@@ -1,30 +1,30 @@
 Source: cp2k
 Section: science
 Priority: optional
-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
 Build-Depends: bc,
                bison,
-               debhelper (>= 7.0.50~),
+               debhelper (>= 10),
                default-jre-headless,
                flex,
-               python, 
+               python2, 
                gfortran,
                libblas-dev,
-               libblacs-mpi-dev,
                libelpa-dev (>= 2016.05.001-1),
                libfftw3-dev,
                libint-dev,
                liblapack-dev,
                libsaxonb-java,
-               libscalapack-mpi-dev,
+               libscalapack-mpi-dev (>= 2),
                libxc-dev (>= 3.0.0-1),
                mpi-default-dev,
 	       pkg-config
-Standards-Version: 3.9.4
+Standards-Version: 4.1.0
 Homepage: http://www.cp2k.org
-Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/cp2k/
-Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/cp2k/
+Vcs-Browser: https://salsa.debian.org/debichem-team/cp2k
+Vcs-Git: https://salsa.debian.org/debichem-team/cp2k.git
 
 Package: cp2k
 Architecture: any
