=== debian/watch ===
version=3
opts=uversionmangle=s/(\d+)\.(\d+)\.(\d+)/$1.$2/ \
https://github.com/cp2k/cp2k/releases .*/archive/v([\d.]+)\.tar\.(?:bz2|gz)
